// Copyright HTC Corporation. All Rights Reserved.

#pragma once

#include "WaveOpenXRSettings.generated.h"

/**
 * WaveOpenXR developer settings
 */
UCLASS(config=Engine, defaultconfig)
class WAVEOPENXREDITOR_API UWaveOpenXRSettings : public UObject
{
	GENERATED_UCLASS_BODY()

public:
	UPROPERTY(EditAnywhere, config, Category = "Hand", meta = (
		ConsoleVariable = "wave.HandInteraction.enable", DisplayName = "Enable Hand Interaction",
		ToolTip = "To enable Hand Interaction feature."))
	bool bHandInteractionEnable;

	UPROPERTY(EditAnywhere, config, Category = "Tracker", meta = (
		ConsoleVariable = "wave.WristTracker.enable", DisplayName = "Enable Wrist Tracker",
		ToolTip = "To modify the AndroidManifest.xml for using the Wrist Tracker feature."))
	bool bWristTrackerEnable;

	UPROPERTY(EditAnywhere, config, Category = "Controller", meta = (
		ConsoleVariable = "wave.ControllerFocus3.enable", DisplayName = "Enable Focus3 Controller",
		ToolTip = "To support Focus3 controller."))
	bool bControllerFocus3Enable;

public:
	//~ Begin UObject Interface
	virtual void PostInitProperties() override;

#if WITH_EDITOR
	virtual void PostEditChangeProperty(FPropertyChangedEvent& PropertyChangedEvent) override;
#endif
	//~ End UObject Interface
};
