// Copyright HTC Corporation. All Rights Reserved.

#pragma once

#include "CoreMinimal.h"
#include "UObject/Interface.h"
#include "WaveGazeInteractInterface.generated.h"

// This class does not need to be modified.
UINTERFACE(MinimalAPI)
class UWaveGazeInteractInterface : public UInterface
{
	GENERATED_BODY()
};

class IWaveGazeInteractInterface
{
	GENERATED_BODY()

	// Add interface functions to this class. This is the class that will be inherited to implement this interface.
public:
	UFUNCTION(BlueprintCallable, BlueprintNativeEvent, Category = "Wave|OpenXR|Interaction")
	void OnGazeEnter(AActor* caller);
	UFUNCTION(BlueprintCallable, BlueprintNativeEvent, Category="Wave|OpenXR|Interaction")
	void OnGazeHover(AActor* caller);
	UFUNCTION(BlueprintCallable, BlueprintNativeEvent, Category = "Wave|OpenXR|Interaction")
	void OnGazeExit(AActor* caller);
	UFUNCTION(BlueprintCallable, BlueprintNativeEvent, Category = "Wave|OpenXR|Interaction")
	void OnGazeClick(AActor* caller);

/**
 * Usage:
 * For the "inherited" UClass object (ex: AActor):
 *
 * IWaveGazeInteractInterface* interface = Cast<IWaveGazeInteractInterface>(<ActorInstance>);
 * if (interface)
 * {
 *     interface->Execute_OnGazeHover(<ActorInstance>, GetOwner());
 * }
 *
 * For the "implemented" Blueprint object (ex: Actor):
 *
 * if (<ActorInstance>->GetClass()->ImplementsInterface(UWaveGazeInteractInterface::StaticClass()))
 * {
 *     IWaveGazeInteractInterface::Execute_OnGazeHover(<ActorInstance>, GetOwner());
 * }
 **/
};
